# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/jboss-ejb3-ext-api/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define namedversion %{version}

Name:           jboss-ejb3-ext-api
Version:        1.0.0
Release:        3.7%{?dist}
Epoch:          0
Summary:        JBoss EJB3 ext api
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn -q export http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/tags/jboss-ejb3-ext-api-1.0.0/
Source0:        jboss-ejb3-ext-api-1.0.0.tar.gz
Source1:        jboss-ejb3-ext-api-jpp-depmap.xml
Source2:        jboss-ejb3-ext-api-settings.xml
Source3:        jboss-ejb3-ext-api-component-info.xml
BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jboss-parent
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:	maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-enforcer-rule-api
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  junit4
BuildRequires:  jboss-ejb-3.0-api
BuildRequires:  jboss-metadata
BuildRequires:  jbossws-parent
BuildRequires:  jboss-javaee
BuildRequires:  jboss-javaee-poms
BuildRequires:  jboss-jms-1.1-api
BuildRequires:  glassfish-jaxws >= 2.1.3
BuildRequires:  gnu-getopt
BuildRequires:  qdox
BuildRequires:  jboss-ejb3-build
BuildRequires:	codehaus-stax11-api

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

Requires:  java >= 0:1.5.0
Requires:  jboss-ejb3-build
Requires:  jboss-ejb-3.0-api
Requires:  jboss-metadata
Requires:  jbossws-parent
Requires:  jboss-javaee
Requires:  jboss-jms-1.1-api
Requires:  glassfish-jaxws
Requires:  gnu-getopt

%description
JBoss EJB3 ext api.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/jboss-ejb3-ext-api.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap org.jboss.ejb3 %{name} %{version} JPP %{name}
install -m 644 target/jboss-ejb3-ext-api-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar
jar -cf $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar -C target/site/apidocs/ .

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
mvn-jpp deploy:deploy-file -e -DpomFile=pom.xml -DrepositoryId=maven2-brew \
    -Durl=file:///%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew \
    -Dfile=$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar \
    -Dclassifier=javadoc

install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-ext-api.jar
cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-ext-api.pom
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}-javadoc.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}-sources.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{version}-javadoc.jar
%{_javadir}*/%{name}-javadoc.jar
%{_javadir}*/%{name}-%{version}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Jan 18 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-3.7
- Rebuild for MEAD
- Change BR junit44 to junit4
- Add BR qdox

* Mon Nov 22 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-3.6
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR maven-deploy-plugin

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-3.5.1.1
- rebuilt

* Tue Apr 20 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0.0-3.5.1
- Rebuild
- Fix depmap entry for dtdparser

* Mon Jan 25 2010 Yong Yang <yyang@redhat.com> 0:1.0.0-3.5
- BuildRequires:	codehaus-stax11-api
- Add needed depmap

* Mon Dec 07 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.0-3.4
- Add javadoc and sources jar files to main package and repolib

* Thu Oct 01 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.0-3.3
- Add pom.xml to repolib

* Tue Aug 25 2009 Yong Yang <yyang@redhat.com> 0:1.0.0-3.2
- replace jboss-ejb3-build.pom with (B)R jboss-ejb3-build

* Tue Aug 25 2009 Yong Yang <yyang@redhat.com> 0:1.0.0-3.1
- Update to 1.0.0-3 from jpackage

* Tue Jul 14 2009 Yong Yang <yyang@redhat.com> 0:1.0.0-2.1
- Import from JPP-6
- Change BR maven-shared-enforcer-rule-api to maven-enforcer-rule-api
- Change jboss-ejb3-build.pom location
- Add (Build)Requires: jbossws-parent, jboss-javaee, jboss-javaee-poms, jboss-jms-1.1-api, gnu-getopt, glassfish-jaxws
- Add jpp-depmap for jboss-ejb-api, jboss-jms-api, jboss-ejb3-build

* Thu Jul 02 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-2
- add repolib

* Tue Jun 30 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.0-1.jpp5
- first release
